/* eslint-disable @next/next/no-img-element */
import CardList from "@/components/High/CardList";
import Layout from "@/components/High/Layout";
import Select from "@/components/Low/Select";
import Tooltip from "@/components/Low/Tooltip";
import { useEntityPermission } from "@/hooks/useEntityPermissions";
import { useListSearch } from "@/hooks/useListSearch";
import usePagination from "@/hooks/usePagination";
import { Entity, EntityWithRoles, Role } from "@/interfaces/entity";
import { GroupWithUsers, User } from "@/interfaces/user";
import { sessionOptions } from "@/lib/session";
import { USER_TYPE_LABELS } from "@/resources/user";
import { findBy, mapBy, redirect, serialize } from "@/utils";
import { getEntityWithRoles } from "@/utils/entities.be";
import { convertToUsers, getGroup } from "@/utils/groups.be";
import { shouldRedirectHome } from "@/utils/navigation.disabled";
import { checkAccess, doesEntityAllow, getTypesOfUser } from "@/utils/permissions";
import { getUserName, isAdmin } from "@/utils/users";
import { filterAllowedUsers, getEntitiesUsers, getEntityUsers, getLinkedUsers, getSpecificUsers, getUsers } from "@/utils/users.be";
import { Menu, MenuButton, MenuItem, MenuItems } from "@headlessui/react";
import axios from "axios";
import clsx from "clsx";
import { withIronSessionSsr } from "iron-session/next";
import moment from "moment";
import Head from "next/head";
import Link from "next/link";
import { useRouter } from "next/router";
import { Divider } from "primereact/divider";
import { useEffect, useMemo, useState } from "react";
import {
	BsChevronLeft,
	BsClockFill,
	BsEnvelopeFill,
	BsFillPersonVcardFill,
	BsHash,
	BsPerson,
	BsPlus,
	BsSquare,
	BsStopwatchFill,
	BsTag,
	BsTrash,
	BsX,
} from "react-icons/bs";
import { toast } from "react-toastify";

export const getServerSideProps = withIronSessionSsr(async ({ req, params }) => {
	const user = req.session.user as User;

	if (!user) return redirect("/login")
	if (shouldRedirectHome(user)) return redirect("/")

	const { id } = params as { id: string };

	const entity = await getEntityWithRoles(id);
	if (!entity) return redirect("/entities")

	if (!doesEntityAllow(user, entity, "view_entities")) return redirect(`/entities`)

	const linkedUsers = await (isAdmin(user) ? getUsers() : getEntitiesUsers(mapBy(user.entities, 'id'),
		{ $and: [{ type: { $ne: "developer" } }, { type: { $ne: "admin" } }] }))
	const entityUsers = await (isAdmin(user) ? getEntityUsers(id) : filterAllowedUsers(user, [entity]));

	const usersWithRole = entityUsers.map((u) => {
		const e = u.entities.find((e) => e.id === id);
		return { ...u, role: findBy(entity.roles, 'id', e?.role) };
	});

	return {
		props: serialize({
			user,
			entity,
			users: usersWithRole,
			linkedUsers: linkedUsers.filter(x => x.id !== user.id && !mapBy(entityUsers, 'id').includes(x.id)),
		}),
	};
}, sessionOptions);

type UserWithRole = User & { role?: Role };

interface Props {
	user: User;
	entity: EntityWithRoles;
	users: UserWithRole[];
	linkedUsers: User[];
}

export default function Home({ user, entity, users, linkedUsers }: Props) {
	const [isAdding, setIsAdding] = useState(false);
	const [isLoading, setIsLoading] = useState(false);
	const [selectedUsers, setSelectedUsers] = useState<string[]>([]);

	const router = useRouter();

	const canRenameEntity = useEntityPermission(user, entity, "rename_entity")
	const canViewRoles = useEntityPermission(user, entity, "view_entity_roles")
	const canDeleteEntity = useEntityPermission(user, entity, "delete_entity")

	const canAddMembers = useEntityPermission(user, entity, "add_to_entity")
	const canRemoveMembers = useEntityPermission(user, entity, "remove_from_entity")

	const canAssignRole = useEntityPermission(user, entity, "assign_to_role")

	const toggleUser = (u: User) => setSelectedUsers((prev) => (prev.includes(u.id) ? prev.filter((p) => p !== u.id) : [...prev, u.id]));

	const removeParticipants = () => {
		if (selectedUsers.length === 0) return;
		if (!canRemoveMembers) return;
		if (!confirm(`Are you sure you want to remove ${selectedUsers.length} member${selectedUsers.length === 1 ? "" : "s"} from this entity?`))
			return;

		setIsLoading(true);

		axios
			.patch(`/api/entities/${entity.id}/users`, { add: false, members: selectedUsers })
			.then(() => {
				toast.success("The entity has been updated successfully!");
				router.replace(router.asPath);
				setSelectedUsers([]);
			})
			.catch((e) => {
				console.error(e);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	};

	const addParticipants = () => {
		if (selectedUsers.length === 0) return;
		if (!canAddMembers || !isAdding) return;
		if (!confirm(`Are you sure you want to add ${selectedUsers.length} member${selectedUsers.length === 1 ? "" : "s"} to this entity?`)) return;

		setIsLoading(true);
		const defaultRole = findBy(entity.roles, 'isDefault', true)!

		axios
			.patch(`/api/entities/${entity.id}/users`, { add: true, members: selectedUsers, role: defaultRole.id })
			.then(() => {
				toast.success("The entity has been updated successfully!");
				router.replace(router.asPath);
				setIsAdding(false);
			})
			.catch((e) => {
				console.error(e);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	};

	const renameGroup = () => {
		if (!canRenameEntity) return;

		const label = prompt("Rename this entity:", entity.label);
		if (!label) return;

		setIsLoading(true);
		axios
			.patch(`/api/entities/${entity.id}`, { label })
			.then(() => {
				toast.success("The entity has been updated successfully!");
				router.replace(router.asPath);
			})
			.catch((e) => {
				console.error(e);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	};

	const editLicenses = () => {
		if (!isAdmin(user)) return;

		const licenses = prompt("Update the number of licenses:", (entity.licenses || 0).toString());
		if (!licenses) return;
		if (!parseInt(licenses) || parseInt(licenses) <= 0) return toast.error("Write a valid number of licenses!")

		setIsLoading(true);
		axios
			.patch(`/api/entities/${entity.id}`, { licenses })
			.then(() => {
				toast.success("The entity has been updated successfully!");
				router.replace(router.asPath);
			})
			.catch((e) => {
				console.error(e);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	};

	const deleteGroup = () => {
		if (!canDeleteEntity) return;
		if (!confirm("Are you sure you want to delete this entity?")) return;

		setIsLoading(true);

		axios
			.delete(`/api/entities/${entity.id}`)
			.then(() => {
				toast.success("This entity has been successfully deleted!");
				router.replace("/entities");
			})
			.catch((e) => {
				console.error(e);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	};

	const assignUsersToRole = (role: string) => {
		if (!canAssignRole) return
		if (selectedUsers.length === 0) return

		setIsLoading(true);
		axios
			.post(`/api/roles/${role}/users`, { users: selectedUsers })
			.then(() => {
				toast.success("The role has been assigned successfully!");
				router.replace(router.asPath);
			})
			.catch((e) => {
				console.error(e);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	}

	const renderCard = (u: UserWithRole) => {
		return (
			<button
				onClick={() => toggleUser(u)}
				disabled={isAdding ? !canAddMembers : !canRemoveMembers}
				key={u.id}
				className={clsx(
					"p-4 pr-6 h-48 relative border rounded-xl flex flex-col gap-3 justify-between text-left cursor-pointer",
					"hover:border-mti-purple transition ease-in-out duration-300",
					selectedUsers.includes(u.id) && "border-mti-purple",
				)}>
				<div className="flex items-center gap-2">
					<div className="min-w-[3rem] min-h-[3rem] w-12 h-12 border flex items-center justify-center overflow-hidden rounded-full">
						<img src={u.profilePicture} alt={u.name} />
					</div>
					<div className="flex flex-col">
						<span className="font-semibold">{getUserName(u)}</span>

						<span className="opacity-80 text-sm">
							{USER_TYPE_LABELS[u.type]} {u.role && `- ${u.role.label}`}
						</span>
					</div>
				</div>

				<div className="flex flex-col gap-1">
					<span className="flex items-center gap-2">
						<Tooltip tooltip="E-mail address">
							<BsEnvelopeFill />
						</Tooltip>
						{u.email}
					</span>
					<span className="flex items-center gap-2">
						<Tooltip tooltip="Expiration Date">
							<BsStopwatchFill />
						</Tooltip>
						{u.subscriptionExpirationDate ? moment(u.subscriptionExpirationDate).format("DD/MM/YYYY") : "Unlimited"}
					</span>
					<span className="flex items-center gap-2">
						<Tooltip tooltip="Last Login">
							<BsClockFill />
						</Tooltip>
						{u.lastLogin ? moment(u.lastLogin).format("DD/MM/YYYY - HH:mm") : "N/A"}
					</span>
				</div>
			</button>
		);
	};

	useEffect(() => setSelectedUsers([]), [isAdding]);

	return (
		<>
			<Head>
				<title>{entity.label} | EnCoach</title>
				<meta
					name="description"
					content="A training platform for the IELTS exam provided by the Muscat Training Institute and developed by eCrop."
				/>
				<meta name="viewport" content="width=device-width, initial-scale=1" />
				<link rel="icon" href="/favicon.ico" />
			</Head>

			<Layout user={user}>
				<section className="flex flex-col gap-0">
					<div className="flex flex-col gap-3">
						<div className="flex items-end justify-between">
							<div className="flex items-center gap-2">
								<Link
									href="/entities"
									className="text-mti-purple hover:text-mti-purple-dark transition ease-in-out duration-300 text-xl">
									<BsChevronLeft />
								</Link>
								<h2 className="font-bold text-2xl">{entity.label} {isAdmin(user) && `- ${entity.licenses || 0} licenses`}</h2>
							</div>
						</div>
						<div className="flex items-center gap-2">
							<button
								onClick={renameGroup}
								disabled={isLoading || !canRenameEntity}
								className="flex items-center gap-1 px-2 py-2 border rounded-full hover:bg-neutral-100 disabled:hover:bg-transparent disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
								<BsTag />
								<span className="text-xs">Rename Entity</span>
							</button>
							{isAdmin(user) && (
								<button
									onClick={editLicenses}
									disabled={isLoading || !isAdmin(user)}
									className="flex items-center gap-1 px-2 py-2 border rounded-full hover:bg-neutral-100 disabled:hover:bg-transparent disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
									<BsHash />
									<span className="text-xs">Edit Licenses</span>
								</button>
							)}
							<button
								onClick={() => router.push(`/entities/${entity.id}/roles`)}
								disabled={isLoading || !canViewRoles}
								className="flex items-center gap-1 px-2 py-2 border rounded-full hover:bg-neutral-100 disabled:hover:bg-transparent disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
								<BsPerson />
								<span className="text-xs">Edit Roles</span>
							</button>
							<button
								onClick={deleteGroup}
								disabled={isLoading || !canDeleteEntity}
								className="flex items-center gap-1 px-2 py-2 border border-mti-rose rounded-full bg-mti-rose-light text-white hover:bg-mti-rose-dark disabled:hover:bg-mti-rose-light disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
								<BsTrash />
								<span className="text-xs">Delete Entity</span>
							</button>
						</div>
					</div>
					<Divider />
					<div className="flex items-center justify-between mb-4">
						<span className="font-semibold text-xl">Members ({users.length})</span>
						{!isAdding && (
							<div className="flex items-center gap-2">
								<button
									onClick={() => setIsAdding(true)}
									disabled={isLoading || !canAddMembers}
									className="flex items-center gap-1 px-2 py-2 border rounded-full hover:bg-neutral-100 disabled:hover:bg-transparent disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
									<BsPlus />
									<span className="text-xs">Add Members</span>
								</button>

								<Menu>
									<MenuButton
										disabled={isLoading || !canAssignRole || selectedUsers.length === 0}
										className="flex items-center gap-1 px-2 py-2 border rounded-full hover:bg-neutral-100 disabled:hover:bg-transparent disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
										<BsPerson />
										<span className="text-xs">Assign Role</span>
									</MenuButton>
									<MenuItems anchor="bottom" className="bg-white rounded-xl shadow drop-shadow border mt-1 flex flex-col">
										{entity.roles.map((role) => (
											<MenuItem key={role.id}>
												<button onClick={() => assignUsersToRole(role.id)} className="p-4 hover:bg-neutral-100 w-32">
													{role.label}
												</button>
											</MenuItem>
										))}
									</MenuItems>
								</Menu>

								<button
									onClick={removeParticipants}
									disabled={selectedUsers.length === 0 || isLoading || !canRemoveMembers}
									className="flex items-center gap-1 px-2 py-2 border border-mti-rose rounded-full bg-mti-rose-light text-white hover:bg-mti-rose-dark disabled:hover:bg-mti-rose-light disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
									<BsTrash />
									<span className="text-xs">Remove Members</span>
								</button>
							</div>
						)}
						{isAdding && (
							<div className="flex items-center gap-2">
								<button
									onClick={() => setIsAdding(false)}
									disabled={isLoading}
									className="flex items-center gap-1 px-2 py-2 border rounded-full border-mti-rose bg-mti-rose-light text-white hover:bg-mti-rose-dark disabled:hover:bg-mti-rose-light disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
									<BsX />
									<span className="text-xs">Discard Selection</span>
								</button>
								<button
									onClick={addParticipants}
									disabled={selectedUsers.length === 0 || isLoading || !canAddMembers}
									className="flex items-center gap-1 px-2 py-2 border rounded-full border-mti-green bg-mti-green-light text-white hover:bg-mti-green-dark disabled:hover:bg-mti-green-light disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
									<BsPlus />
									<span className="text-xs">Add Members ({selectedUsers.length})</span>
								</button>
							</div>
						)}
					</div>

					<CardList<User | UserWithRole>
						list={isAdding ? linkedUsers : users}
						renderCard={renderCard}
						searchFields={[["name"], ["email"], ["corporateInformation", "companyInformation", "name"], ["role", "label"], ["type"]]}
					/>
				</section>
			</Layout>
		</>
	);
}
